/* genvec charvec char ; 1999-09-24 02:06:26 */
#ifndef HAS_GEN_charvec_H
#define HAS_GEN_charvec_H

#include <stdlib.h>
#include <string.h>
#include <assert.h>

typedef void *((*realloc_t)(void*, size_t));
typedef void (*free_t)(void*);

typedef struct charvec {
    char *a;
    unsigned int len;
    unsigned int max;
    realloc_t alloc;
    free_t free;
} charvec_t;

#define charvec_INIT(a,f)  {0, 0, 0, a, f}

charvec_t* charvec_new(realloc_t alloc, free_t free);
charvec_t* charvec_free(charvec_t *t);
int charvec_init(charvec_t *t, realloc_t alloc, free_t free);
int charvec_fini(charvec_t *t);
int charvec_need(charvec_t *t, unsigned int n);
int charvec_more(charvec_t *t, unsigned int n);
int charvec_append(charvec_t *t, char e);
int charvec_fit(charvec_t *t);
#endif

