#ifndef __lint
/*@unused@ */
static const char rcsid[] = 
"$Id: mbalign.c,v 1.30 1999/04/28 21:58:19 schwartz Exp $";
#endif

#include "psublast/libc.h"
#include "psublast/psublast.h"
#include "mbalign.h"
#include "galign.h"

static int extend_gap_align_internal(gal_t *m,
		int X, int M, int R, int G, int E, int l1, const uchar *s1, int l2, const uchar *s2, int scr)
{
    int b1, b2, e1, e2, i;
    edit_script_t *scr1 = 0, *scr2 = 0;

    if (scr) {
        scr1 = edit_script_new();
        scr2 = edit_script_new();
    }

    /* nb. msp is 1-indexed; align is 1-indexed */

    /* Align forward from end of the msp, and backwards from the beginning. */
    i = gap_align_basic(s1+m->e1, l1-m->e1, s2+m->e2, l2-m->e2, 0,X,M,R,G,E, &e1,&e2,scr1)
      + gap_align_basic(s1,       m->b1-1,  s2,       m->b2-1,  1,X,M,R,G,E, &b1,&b2,scr2);

    if (scr) {
	/* The improved alignment is the computed scripts, joined by the msp. */
        edit_script_rep(scr2, m->e1 - m->b1 + 1);
        edit_script_append(scr2, scr1);
        edit_script_free(scr1);
    }

    if (G!=0 || E*2!=R*2+M) i += (m->e1-m->b1+1)*M;
    m->e1 += e1;
    m->e2 += e2;
    m->b1 -= b1;
    m->b2 -= b2;
    m->S = scr2;
    return i;
}

int mb_extend_gap_align_script(gal_t *mq, int X, int M, int R, int G, int E, const uchar *s1, int l1, const uchar *s2, int l2)
{
    int i = extend_gap_align_internal(mq, X, M, R, G, E, l1, s1, l2, s2, 1);
    /*print_align_lav(mq->diag, s1, s2, 
      mq->b1, mq->e1, mq->b2, mq->e2, mq->S);*/
    return i;
}

int mb_extend_gap_align(gal_t *mq, int X, int M, int R, int G, int E, const uchar *s1, int l1, const uchar *s2, int l2)
{
    return extend_gap_align_internal(mq, X, M, R, G, E, l1, s1, l2, s2, 0);
}
