#include "psublast/libc.h"
#include "psublast/types.h"
#include "psublast/misc.h"
#include "psublast/score.h"

static const char rcsid[] =
"$Id: score.c,v 1.5 1999/03/23 21:22:47 schwartz Exp $";

int scores_from_fp(FILE *fp, ss_t ss)
{
	char buf[1024];
	uchar code[255];
	char *p;
	int n, i, j, s;

	if (fgets(buf, sizeof buf, fp) == 0)
		fatal("cannot read score file");

	/* XXX - strtok isn't thread safe */
	for (n=0, p=strtok(buf, " \t\n"); p; p=strtok(0, " \t\n"), ++n) {
		code[n] = *(uchar*)p;
	}

	for (i=0; i < n; ++i) {
		for (j=0; j < n; ++j) {
			if (fscanf(fp, " %d", &s) == 1) {
				ss[code[i]][code[j]] = s;
			} else {
				fatal("cannot read score file");
			}
		}
	}
	return 1;
}

int scores_from_file(const char *fname, ss_t ss)
{
	FILE *fp;

	fp = fopen(fname, "r");
	if (fp == 0)
		fatalfr("cannot open score file '%s'");
	else
		return scores_from_fp(fp, ss);
}

int print_scores(FILE *fp, ss_t ss)
{
	int i, j;

	for (i='A'; i <= 'Z'; ++i) {
		for (j='A'; j <= 'Z'; ++j) {
			fprintf(fp, "%d ", ss[i][j]);
		}
		fprintf(fp, "\n");
	}
	return ferror(fp);
}

#ifdef TEST
int main(int argc, char **argv)
{
	ss_t ss;
	if (argc>1) {
		scores_from_file(argv[1], ss);
		print_scores(stdout, ss);
	}
}
#endif

