#ifndef __lint
static const char rcsid[] =
"$Id: unpack.c,v 1.4 1999/09/23 21:24:09 schwartz Exp $";
#endif

#include "psublast/libc.h"
#include "psublast/psublast.h"
#include "unpack.h"

uchar* readdb_unpack(const uchar* seq, int len)
{
    uchar *s, *t;
    int i, j;
    const unsigned char *const code = fasta_decoding;

    t = s = ckalloc(len + 2 + 1);
    for (i = 0; i < len / 4; i++) {
	*t++ = code[READDB_UNPACK_BASE_1(seq[i])];
	*t++ = code[READDB_UNPACK_BASE_2(seq[i])];
	*t++ = code[READDB_UNPACK_BASE_3(seq[i])];
	*t++ = code[READDB_UNPACK_BASE_4(seq[i])];
    }
    if (len % 4 != 0) {
	j = seq[i] % 4;
	i = seq[i];
	/*debugf("%d %d\n",j, i); */
	for (; j > 0; j--) {
	    *t++ = code[(i & 192) >> 6];
	    i = (i << 2);
	}
    }
    *t = '\0';
    return s;
}

